% pi_checkpoint_ex5.m:
%    - Calcul de l'approximation de pi par la mthode de Leibniz
%    - le programme simule un job long  avec des instructions "pause" inutiles
%  avec un checkpoint  intevalle de temps rgulier. 
%    - Il s'agit juste d'un exemple ...le choix de placer deux tests "if", une 
%   ventuelle sauvegarde dans une boucle qui contient seulement 3 instructions 
%   de calculs lmentaire est videmment trs critiquable!
%
%    - Le problme des checkpoint est  prendre en considration si vous soumettez
%    des jobs de trs longue dure sur le cluster ( pannes , coupures de courant,
%    jobs soumis sur des files besteffort, long ,...)
% 
% Note: le script pi_checkpoint_ex5.m peut-tre tester avec Matlab en mode
% interactif:  il suffit de le stopper avec CTRL+C (et le relancer une 2ime fois)
%

if exist('check.mat')
    % initialise les donnes au redmarrage
    fprintf('restart aprs arrt\n');  
    load('check.mat');  
    fprintf('valeur provisoire de pi: %f et iteration %d \n',4*approxpi,n);
    % modif du flag 'passe' pour supprimer les pauses et finir le calcul
    passe = 0;
    save('check.mat');
else
    Nmax=1000;
    approxpi=0;
    fac=1;
    n=1;
    passe=1;
    save('check.mat','Nmax','approxpi','fac','n','passe');
end 
t = clock;
% environ 30 secondes entre chaque checkpoint
intervalle_checkpnt=30;
while( n < Nmax )
    approxpi=approxpi+fac/(2*n-1);
    fac=-fac;
    n=n+1;
    % simulation d'un job long...
    if ( passe == 1 )
        pause(2)
    end
    % checkpoint
    if( etime(clock,t) >= intervalle_checkpnt )           
        fprintf('checkpoint, indice de boucle = %d \n', n );  
        save('check.mat','Nmax','approxpi','fac','n','passe');
        %pause( 1 );
        t = clock;
    end
end
approxpi=4*approxpi;
fprintf('\n approximation de pi: %f aprs %d itrations\n',approxpi,Nmax); 
% suppression du fichier checkpoint
delete('check.mat');

% merci de quitter matlab pour librer les jetons de licence.
 quit 
